EAPI EAPI_WEAK const Efl_Event_Description _EFL_UI_LAYOUT_EVENT_THEME_CHANGED =
   EFL_EVENT_DESCRIPTION("theme,changed");

void _efl_ui_layout_base_finger_size_multiplier_set(Eo *obj, Efl_Ui_Layout_Data *pd, unsigned int multiplier_x, unsigned int multiplier_y);

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_ui_layout_finger_size_multiplier_set, EFL_FUNC_CALL(multiplier_x, multiplier_y), unsigned int multiplier_x, unsigned int multiplier_y);

void _efl_ui_layout_base_finger_size_multiplier_get(const Eo *obj, Efl_Ui_Layout_Data *pd, unsigned int *multiplier_x, unsigned int *multiplier_y);

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV_CONST(efl_ui_layout_finger_size_multiplier_get, EFL_FUNC_CALL(multiplier_x, multiplier_y), unsigned int *multiplier_x, unsigned int *multiplier_y);

Eina_Error _efl_ui_layout_base_theme_set(Eo *obj, Efl_Ui_Layout_Data *pd, const char *klass, const char *group, const char *style);

EAPI EAPI_WEAK EFL_FUNC_BODYV(efl_ui_layout_theme_set, Eina_Error, 0, EFL_FUNC_CALL(klass, group, style), const char *klass, const char *group, const char *style);

void _efl_ui_layout_base_theme_get(const Eo *obj, Efl_Ui_Layout_Data *pd, const char **klass, const char **group, const char **style);

static void __eolian_efl_ui_layout_base_theme_get(const Eo *obj, Efl_Ui_Layout_Data *pd, const char **klass, const char **group, const char **style)
{
   if (group) *group = "base";
   if (style) *style = "default";
   _efl_ui_layout_base_theme_get(obj, pd, klass, group, style);
}

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV_CONST(efl_ui_layout_theme_get, EFL_FUNC_CALL(klass, group, style), const char **klass, const char **group, const char **style);

void _efl_ui_layout_base_automatic_theme_rotation_set(Eo *obj, Efl_Ui_Layout_Data *pd, Eina_Bool automatic);


static Eina_Error
__eolian_efl_ui_layout_base_automatic_theme_rotation_set_reflect(Eo *obj, Eina_Value val)
{
   Eina_Error r = 0;   Eina_Bool cval;
   if (!eina_value_bool_convert(&val, &cval))
      {
         r = EINA_ERROR_VALUE_FAILED;
         goto end;
      }
   efl_ui_layout_automatic_theme_rotation_set(obj, cval);
 end:
   eina_value_flush(&val);
   return r;
}

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_ui_layout_automatic_theme_rotation_set, EFL_FUNC_CALL(automatic), Eina_Bool automatic);

Eina_Bool _efl_ui_layout_base_automatic_theme_rotation_get(const Eo *obj, Efl_Ui_Layout_Data *pd);


static Eina_Value
__eolian_efl_ui_layout_base_automatic_theme_rotation_get_reflect(const Eo *obj)
{
   Eina_Bool val = efl_ui_layout_automatic_theme_rotation_get(obj);
   return eina_value_bool_init(val);
}

EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_ui_layout_automatic_theme_rotation_get, Eina_Bool, 0);

void _efl_ui_layout_base_theme_rotation_apply(Eo *obj, Efl_Ui_Layout_Data *pd, int orientation);

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_ui_layout_theme_rotation_apply, EFL_FUNC_CALL(orientation), int orientation);

int _efl_ui_layout_base_theme_version_get(const Eo *obj, Efl_Ui_Layout_Data *pd);


static Eina_Value
__eolian_efl_ui_layout_base_theme_version_get_reflect(const Eo *obj)
{
   int val = efl_ui_layout_theme_version_get(obj);
   return eina_value_int_init(val);
}

EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_ui_layout_theme_version_get, int, 0);

Efl_Object *_efl_ui_layout_base_efl_object_constructor(Eo *obj, Efl_Ui_Layout_Data *pd);


Efl_Object *_efl_ui_layout_base_efl_object_finalize(Eo *obj, Efl_Ui_Layout_Data *pd);


void _efl_ui_layout_base_efl_object_invalidate(Eo *obj, Efl_Ui_Layout_Data *pd);


void _efl_ui_layout_base_efl_canvas_group_group_calculate(Eo *obj, Efl_Ui_Layout_Data *pd);


void _efl_ui_layout_base_efl_canvas_group_group_change(Eo *obj, Efl_Ui_Layout_Data *pd);


int _efl_ui_layout_base_efl_layout_calc_calc_freeze(Eo *obj, Efl_Ui_Layout_Data *pd);


int _efl_ui_layout_base_efl_layout_calc_calc_thaw(Eo *obj, Efl_Ui_Layout_Data *pd);


void _efl_ui_layout_base_efl_layout_calc_calc_auto_update_hints_set(Eo *obj, Efl_Ui_Layout_Data *pd, Eina_Bool update);


Eina_Bool _efl_ui_layout_base_efl_layout_calc_calc_auto_update_hints_get(const Eo *obj, Efl_Ui_Layout_Data *pd);


Eina_Size2D _efl_ui_layout_base_efl_layout_calc_calc_size_min(Eo *obj, Efl_Ui_Layout_Data *pd, Eina_Size2D restricted);


Eina_Rect _efl_ui_layout_base_efl_layout_calc_calc_parts_extends(Eo *obj, Efl_Ui_Layout_Data *pd);


void _efl_ui_layout_base_efl_layout_calc_calc_force(Eo *obj, Efl_Ui_Layout_Data *pd);


Eina_Bool _efl_ui_layout_base_efl_layout_signal_signal_callback_add(Eo *obj, Efl_Ui_Layout_Data *pd, const char *emission, const char *source, void *func_data, EflLayoutSignalCb func, Eina_Free_Cb func_free_cb);


Eina_Bool _efl_ui_layout_base_efl_layout_signal_signal_callback_del(Eo *obj, Efl_Ui_Layout_Data *pd, const char *emission, const char *source, void *func_data, EflLayoutSignalCb func, Eina_Free_Cb func_free_cb);


void _efl_ui_layout_base_efl_layout_signal_signal_emit(Eo *obj, Efl_Ui_Layout_Data *pd, const char *emission, const char *source);


void _efl_ui_layout_base_efl_layout_signal_message_send(Eo *obj, Efl_Ui_Layout_Data *pd, int id, const Eina_Value msg);


void _efl_ui_layout_base_efl_layout_signal_signal_process(Eo *obj, Efl_Ui_Layout_Data *pd, Eina_Bool recurse);


const char *_efl_ui_layout_base_efl_layout_group_group_data_get(const Eo *obj, Efl_Ui_Layout_Data *pd, const char *key);


Eina_Size2D _efl_ui_layout_base_efl_layout_group_group_size_min_get(const Eo *obj, Efl_Ui_Layout_Data *pd);


Eina_Size2D _efl_ui_layout_base_efl_layout_group_group_size_max_get(const Eo *obj, Efl_Ui_Layout_Data *pd);


Eina_Bool _efl_ui_layout_base_efl_layout_group_part_exist_get(const Eo *obj, Efl_Ui_Layout_Data *pd, const char *part);


Eina_Bool _efl_ui_layout_base_efl_ui_widget_widget_sub_object_add(Eo *obj, Efl_Ui_Layout_Data *pd, Efl_Canvas_Object *sub_obj);


Eina_Error _efl_ui_layout_base_efl_ui_widget_theme_apply(Eo *obj, Efl_Ui_Layout_Data *pd);


void _efl_ui_layout_base_efl_ui_widget_disabled_set(Eo *obj, Efl_Ui_Layout_Data *pd, Eina_Bool disabled);


Eina_Bool _efl_ui_layout_base_efl_ui_widget_widget_sub_object_del(Eo *obj, Efl_Ui_Layout_Data *pd, Efl_Canvas_Object *sub_obj);


Eina_Bool _efl_ui_layout_base_efl_ui_focus_object_on_focus_update(Eo *obj, Efl_Ui_Layout_Data *pd);


int _efl_ui_layout_base_efl_container_content_count(Eo *obj, Efl_Ui_Layout_Data *pd);


Eina_Iterator *_efl_ui_layout_base_efl_container_content_iterate(Eo *obj, Efl_Ui_Layout_Data *pd);


Efl_Object *_efl_ui_layout_base_efl_part_part_get(const Eo *obj, Efl_Ui_Layout_Data *pd, const char *name);


Eina_Error _efl_ui_layout_base_efl_ui_property_bind_property_bind(Eo *obj, Efl_Ui_Layout_Data *pd, const char *key, const char *property);


Eina_Error _efl_ui_layout_base_efl_ui_factory_bind_factory_bind(Eo *obj, Efl_Ui_Layout_Data *pd, const char *key, Efl_Ui_Factory *factory);


void _efl_ui_layout_base_efl_ui_l10n_l10n_text_set(Eo *obj, Efl_Ui_Layout_Data *pd, const char *label, const char *domain);


const char *_efl_ui_layout_base_efl_ui_l10n_l10n_text_get(const Eo *obj, Efl_Ui_Layout_Data *pd, const char **domain);


void _efl_ui_layout_base_efl_ui_i18n_language_set(Eo *obj, Efl_Ui_Layout_Data *pd, const char *language);


const char *_efl_ui_layout_base_efl_ui_i18n_language_get(const Eo *obj, Efl_Ui_Layout_Data *pd);


static Eina_Bool
_efl_ui_layout_base_class_initializer(Efl_Class *klass)
{
   const Efl_Object_Ops *opsp = NULL;

   const Efl_Object_Property_Reflection_Ops *ropsp = NULL;

#ifndef EFL_UI_LAYOUT_BASE_EXTRA_OPS
#define EFL_UI_LAYOUT_BASE_EXTRA_OPS
#endif

   EFL_OPS_DEFINE(ops,
      EFL_OBJECT_OP_FUNC(efl_ui_layout_finger_size_multiplier_set, _efl_ui_layout_base_finger_size_multiplier_set),
      EFL_OBJECT_OP_FUNC(efl_ui_layout_finger_size_multiplier_get, _efl_ui_layout_base_finger_size_multiplier_get),
      EFL_OBJECT_OP_FUNC(efl_ui_layout_theme_set, _efl_ui_layout_base_theme_set),
      EFL_OBJECT_OP_FUNC(efl_ui_layout_theme_get, __eolian_efl_ui_layout_base_theme_get),
      EFL_OBJECT_OP_FUNC(efl_ui_layout_automatic_theme_rotation_set, _efl_ui_layout_base_automatic_theme_rotation_set),
      EFL_OBJECT_OP_FUNC(efl_ui_layout_automatic_theme_rotation_get, _efl_ui_layout_base_automatic_theme_rotation_get),
      EFL_OBJECT_OP_FUNC(efl_ui_layout_theme_rotation_apply, _efl_ui_layout_base_theme_rotation_apply),
      EFL_OBJECT_OP_FUNC(efl_ui_layout_theme_version_get, _efl_ui_layout_base_theme_version_get),
      EFL_OBJECT_OP_FUNC(efl_constructor, _efl_ui_layout_base_efl_object_constructor),
      EFL_OBJECT_OP_FUNC(efl_finalize, _efl_ui_layout_base_efl_object_finalize),
      EFL_OBJECT_OP_FUNC(efl_invalidate, _efl_ui_layout_base_efl_object_invalidate),
      EFL_OBJECT_OP_FUNC(efl_canvas_group_calculate, _efl_ui_layout_base_efl_canvas_group_group_calculate),
      EFL_OBJECT_OP_FUNC(efl_canvas_group_change, _efl_ui_layout_base_efl_canvas_group_group_change),
      EFL_OBJECT_OP_FUNC(efl_layout_calc_freeze, _efl_ui_layout_base_efl_layout_calc_calc_freeze),
      EFL_OBJECT_OP_FUNC(efl_layout_calc_thaw, _efl_ui_layout_base_efl_layout_calc_calc_thaw),
      EFL_OBJECT_OP_FUNC(efl_layout_calc_auto_update_hints_set, _efl_ui_layout_base_efl_layout_calc_calc_auto_update_hints_set),
      EFL_OBJECT_OP_FUNC(efl_layout_calc_auto_update_hints_get, _efl_ui_layout_base_efl_layout_calc_calc_auto_update_hints_get),
      EFL_OBJECT_OP_FUNC(efl_layout_calc_size_min, _efl_ui_layout_base_efl_layout_calc_calc_size_min),
      EFL_OBJECT_OP_FUNC(efl_layout_calc_parts_extends, _efl_ui_layout_base_efl_layout_calc_calc_parts_extends),
      EFL_OBJECT_OP_FUNC(efl_layout_calc_force, _efl_ui_layout_base_efl_layout_calc_calc_force),
      EFL_OBJECT_OP_FUNC(efl_layout_signal_callback_add, _efl_ui_layout_base_efl_layout_signal_signal_callback_add),
      EFL_OBJECT_OP_FUNC(efl_layout_signal_callback_del, _efl_ui_layout_base_efl_layout_signal_signal_callback_del),
      EFL_OBJECT_OP_FUNC(efl_layout_signal_emit, _efl_ui_layout_base_efl_layout_signal_signal_emit),
      EFL_OBJECT_OP_FUNC(efl_layout_signal_message_send, _efl_ui_layout_base_efl_layout_signal_message_send),
      EFL_OBJECT_OP_FUNC(efl_layout_signal_process, _efl_ui_layout_base_efl_layout_signal_signal_process),
      EFL_OBJECT_OP_FUNC(efl_layout_group_data_get, _efl_ui_layout_base_efl_layout_group_group_data_get),
      EFL_OBJECT_OP_FUNC(efl_layout_group_size_min_get, _efl_ui_layout_base_efl_layout_group_group_size_min_get),
      EFL_OBJECT_OP_FUNC(efl_layout_group_size_max_get, _efl_ui_layout_base_efl_layout_group_group_size_max_get),
      EFL_OBJECT_OP_FUNC(efl_layout_group_part_exist_get, _efl_ui_layout_base_efl_layout_group_part_exist_get),
      EFL_OBJECT_OP_FUNC(efl_ui_widget_sub_object_add, _efl_ui_layout_base_efl_ui_widget_widget_sub_object_add),
      EFL_OBJECT_OP_FUNC(efl_ui_widget_theme_apply, _efl_ui_layout_base_efl_ui_widget_theme_apply),
      EFL_OBJECT_OP_FUNC(efl_ui_widget_disabled_set, _efl_ui_layout_base_efl_ui_widget_disabled_set),
      EFL_OBJECT_OP_FUNC(efl_ui_widget_sub_object_del, _efl_ui_layout_base_efl_ui_widget_widget_sub_object_del),
      EFL_OBJECT_OP_FUNC(efl_ui_focus_object_on_focus_update, _efl_ui_layout_base_efl_ui_focus_object_on_focus_update),
      EFL_OBJECT_OP_FUNC(efl_content_count, _efl_ui_layout_base_efl_container_content_count),
      EFL_OBJECT_OP_FUNC(efl_content_iterate, _efl_ui_layout_base_efl_container_content_iterate),
      EFL_OBJECT_OP_FUNC(efl_part_get, _efl_ui_layout_base_efl_part_part_get),
      EFL_OBJECT_OP_FUNC(efl_ui_property_bind, _efl_ui_layout_base_efl_ui_property_bind_property_bind),
      EFL_OBJECT_OP_FUNC(efl_ui_factory_bind, _efl_ui_layout_base_efl_ui_factory_bind_factory_bind),
      EFL_OBJECT_OP_FUNC(efl_ui_l10n_text_set, _efl_ui_layout_base_efl_ui_l10n_l10n_text_set),
      EFL_OBJECT_OP_FUNC(efl_ui_l10n_text_get, _efl_ui_layout_base_efl_ui_l10n_l10n_text_get),
      EFL_OBJECT_OP_FUNC(efl_ui_language_set, _efl_ui_layout_base_efl_ui_i18n_language_set),
      EFL_OBJECT_OP_FUNC(efl_ui_language_get, _efl_ui_layout_base_efl_ui_i18n_language_get),
      EFL_UI_LAYOUT_BASE_EXTRA_OPS
   );
   opsp = &ops;

   static const Efl_Object_Property_Reflection refl_table[] = {
      {"automatic_theme_rotation", __eolian_efl_ui_layout_base_automatic_theme_rotation_set_reflect, __eolian_efl_ui_layout_base_automatic_theme_rotation_get_reflect},
      {"theme_version", NULL, __eolian_efl_ui_layout_base_theme_version_get_reflect},
   };
   static const Efl_Object_Property_Reflection_Ops rops = {
      refl_table, EINA_C_ARRAY_LENGTH(refl_table)
   };
   ropsp = &rops;

   return efl_class_functions_set(klass, opsp, ropsp);
}

static const Efl_Class_Description _efl_ui_layout_base_class_desc = {
   EO_VERSION,
   "Efl.Ui.Layout_Base",
   EFL_CLASS_TYPE_REGULAR_NO_INSTANT,
   sizeof(Efl_Ui_Layout_Data),
   _efl_ui_layout_base_class_initializer,
   _efl_ui_layout_base_class_constructor,
   NULL
};

EFL_DEFINE_CLASS(efl_ui_layout_base_class_get, &_efl_ui_layout_base_class_desc, EFL_UI_WIDGET_CLASS, EFL_CONTAINER_INTERFACE, EFL_UI_FACTORY_BIND_INTERFACE, EFL_LAYOUT_CALC_INTERFACE, EFL_LAYOUT_SIGNAL_INTERFACE, EFL_LAYOUT_GROUP_INTERFACE, NULL);
